
#include "utilities.h"
#include "InOut.h"


#define RRR            6378.388
#ifndef PI             /* as in stroustrup */
#define PI             3.14159265358979323846
#endif


struct point {
  double x;
  double y;
};

struct problem{
  char          name[LINE_BUF_LEN];     /* instance name */
  long int      n;                      /* number of cities */
  long int      **distance;	        /* distance matrix: distance[i][j] gives distance 
					   between location i und j */
  long int      **flow;	                /* flow matrix: flow[i][j] gives flow 
					   between item i und j */
  long int      **nn_list;              /* nearest neighbor list; contains for each node i a
                                           sorted list of n_near nearest neighbors */
};

extern struct problem instance;

extern long int n;        

double surrogate_tour_length(long int * x, std::string result);

double surrogate_tour_length( VectorXl x, std::string result);

long int compute_tour_length( long int *p );

long int compute_tour_length( VectorXl t  );

void read_problem_size( FILE *input );

void read_best_known_value( FILE *input );

long int ** read_matrix( FILE *input, long int size );
